#ifndef OS_H
#define OS_H

#include "types.h"
#include "stdarg.h"
#include "string.h"

#include "tss.h"
#include "pte.h"
#include "gdt.h"
#include "syspage.h"

#include "pe.h"

#include "thread.h"

#include "intr.h"
#include "pic.h"
#include "pit.h"
#include "video.h"
#include "keyboard.h"

void kprintf(const char *fmt, ...);
int vsprintf(char *buf, const char *fmt, va_list args);

void dump_memory(unsigned char *p, int len);

// intrinsic functions

void *memcpy(void *, const void *, size_t);

int __cdecl _inp(unsigned short);
unsigned short __cdecl _inpw(unsigned short);
unsigned long __cdecl _inpd(unsigned short);

int __cdecl outp(unsigned short, int);
unsigned short __cdecl _outpw(unsigned short, unsigned short);
unsigned long __cdecl _outpd(unsigned short, unsigned long);

#endif
