#ifndef PTE_H
#define PTE_H

#define PAGESIZE       4096
#define PAGESHIFT      12
#define PTES_PER_PAGE  (PAGESIZE / sizeof(pte))

typedef unsigned long pte;

#define PT_PRESENT   0x001
#define PT_WRITABLE  0x002
#define	PT_USER      0x004
#define PT_ACCESSED  0x020
#define PT_DIRTY     0x040
#define PT_PFN	     0xFFFFF000
#define PT_PFNSHIFT  12

#define L1IDX(vaddr) (((unsigned long) vaddr) >> 22)
#define L2IDX(vaddr) ((((unsigned long) vaddr) >> 12) & 0x3FF)
#define PGOFF(vaddr) (((unsigned long) vaddr) & 0xFFF) 
#define PAGES(x) (((unsigned long)(x) + (PAGESIZE - 1)) >> PAGESHIFT)

#endif