#ifndef SYSPAGE_H
#define SYSPAGE_H

#define GDT_NULL    0
#define GDT_KTEXT   1
#define GDT_KDATA   2
#define GDT_UTEXT   3
#define GDT_UDATA   4
#define GDT_TSS     5

#define MAXGDT 6
#define MAXIDT 64

#define SEL_NULL    0
#define SEL_KTEXT   8
#define SEL_KDATA   16
#define SEL_UTEXT   24
#define SEL_UDATA   32
#define SEL_TSS     40

struct syspage
{
  struct tss tss;
  struct segment gdt[MAXGDT];
  struct gate idt[MAXIDT];
};

#define OSBASE      0x80000000
#define PTBASE      0x90000000
#define SYSBASE     0x90400000
#define TCBBASE     0x90800000

#define SYSPAGE_ADDRESS (SYSBASE + 0 * PAGESIZE)
#define PAGEDIR_ADDRESS (SYSBASE + 1 * PAGESIZE)
#define INITSTK_ADDRESS (SYSBASE + 2 * PAGESIZE)
#define VIDBASE_ADDRESS (SYSBASE + 3 * PAGESIZE)

#endif
