#ifndef THREAD_H
#define THREAD_H

#if 0

#define WAIT_ALL 0
#define WAIT_ANY 1

#define OBJECT_THREAD    0
#define OBJECT_EVENT     1
#define OBJECT_TIMER     2
#define OBJECT_MUTEX     3
#define OBJECT_SEMAPHORE 4
#define OBJECT_FILE      5
#define OBJECT_DPC       6

#define THREAD_STATE_INITIALIZED 0
#define THREAD_STATE_READY       1
#define THREAD_STATE_STANDBY     2
#define THREAD_STATE_RUNNING     3
#define THREAD_STATE_WAITING     4
#define THREAD_STATE_TRANSITION  5
#define THREAD_STATE_TERMINATED  6

struct context
{
};

struct object
{
  unsigned char type;
  unsigned char signaled;

  int handle_count;

  struct waitblock *waitlist_head;
  struct waitblock *waitlist_tail;
}

struct waitblock
{
  struct thread *thread;
  struct object *object;

  struct waitblock *next_thread;
  struct waitblock *prev_thread;

  struct waitblock *next_object;
  struct waitblock *prev_object;
};

struct timer
{
  struct object object;
  unsigned int expires;

  struct timer *next_timer;
  struct timer *prev_timer;
};

struct thread
{
  struct object object;

  int state;
  int priority;
  struct context context;

  struct waitblock *waitlist;
  unsigned char waittype;
  struct timer timeout;
};

struct module
{
  struct object object;
}

#endif


#endif